#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "arrayproxy4xi.py">
#<abstract4xi abstract = "Provides type ArrayProxy4Xi" />
#<refer4xi reference = "managers.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'MakeProxyType4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import MakeProxyType
except:
    print("arrayproxy4xi.py *** failed in from multiprocessing.managers import MakeProxyType ***")
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from baseproxy4xi import BaseProxy4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "MakeProxyType4Xi" usage = "
#   function embedded inside this module
#   so that ForkingPickler4Xi determines this one as THE module 
#
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

def MakeProxyType4Xi(name, exposed, cache={}):
    '''
    MakeProxyType4Xi function: returns an proxy type whose methods are given by `exposed`;
    
    '''
    class2print = "MakeProxyType4Xi"
    method2print = "MakeProxyType4Xi"
    
    message2print = "{started" + "; MakeProxyType4Xi-started: " + str(MakeProxyType4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    
   
    message2print = "{passed" + "; name-passed-to-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    message2print = "{passed" + "; exposed-passed-to-MakeProxyType4Xi: " + str(exposed) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    message2print = "{passed" + "; cache-passed-to-MakeProxyType4Xi: " + str(cache) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   


    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    exposed2xi = tuple(exposed)
    
    message2print = "{set; exposed2xi-set-by-MakeProxyType4Xi to: " + str(exposed2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
    try:

        message2print = "{passing" + "; name-passing-to-cache-by-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
      

        message2print = "{passing" + "; exposed2xi-passing-to-cache-by-MakeProxyType4Xi: " + str(exposed2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
          
        message2print = "{returning" + "; cache-passing-returning-by-MakeProxyType4Xi:" +str(cache) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        return cache[(name, exposed2xi)]
        
    except KeyError:
    
        message2print = "{hit; KeyError-with-name-hit-by-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{hit; KeyError-with-exposed2xi-hit-by-MakeProxyType4Xi: " + str(exposed2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)              
        
        

    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    dic2xi = {}
        
    message2print = "{entering" + "; for-loop-with-exposed2xi-entering-by-MakeProxyType4Xi: " + str(exposed2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
            

        
    for meth2xi in exposed2xi:
        exec('''def %s(self, *args, **kwds):
        return self._callmethod(%r, args, kwds)''' % (meth2xi, meth2xi), dic2xi)
    
    message2print = "{performed" + "; for-loop-with-meth2xi-performed-by-MakeProxyType4Xi: " + str(meth2xi)+ "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
  
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
   
    ProxyType2Xi = type(name, (BaseProxy4Xi,), dic2xi)
    
    message2print = "{setting; ProxyType2Xi-setting-by-MakeProxyType4Xi to: " + str(ProxyType2Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    
    ProxyType2Xi._exposed_ = exposed2xi

    message2print = "{set; ProxyType2Xi-exposed-set-by-MakeProxyType4Xi to: " + str(ProxyType2Xi._exposed_)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
    cache[(name, exposed2xi)] = ProxyType2Xi

    message2print = "{set" + "; cache-set-by-MakeProxyType4Xi to: " + str(cache)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
 
    
    message2print = "{returning" + "; ProxyType2Xi-returning-by-MakeProxyType4Xi: " + str(ProxyType2Xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)       
    
    return ProxyType2Xi
#</function4xi>


# -------------------------------------------------------------------------------------------------
# Types                              
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
#
#<type4xi type = "
ArrayProxy4Xi = MakeProxyType4Xi('ArrayProxy4Xi', (
    '__len__', '__getitem__', '__setitem__'))                  

#usage = "
#     syncmanager4xi.py
#         class SyncManager4Xi:
#             __init__:
#                 register('Array4Xi', Array4Xi, ArrayProxy4Xi)
#"
#/>

    
    

#Example:    
# { SyncManager4Xi : register ; cls: <class 'syncmanager4xi.SyncManager4Xi'>; typeid: Array4Xi; callable: <function Array4Xi at 0x00000000034A29C8>; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; proxytype: <class 'makeproxytype4xi.ArrayProxy4Xi'>; exposed: None; method_to_typeid: None; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; create_method: True; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; set exposed to: ('__len__', '__getitem__', '__setitem__', '__sense__', '__reason__', '__ace__'); time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; set method_to_typeid to: None; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; asserted ok: method_to_typeid; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; set : cls._registry; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; callable to: <function Array4Xi at 0x00000000034A29C8>; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; exposed to: ('__len__', '__getitem__', '__setitem__', '__sense__', '__reason__', '__ace__'); time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; method_to_typeid to: None; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; proxytype to: <class 'makeproxytype4xi.ArrayProxy4Xi'>; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; set temp.__name__ to: Array4Xi; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; performed: setattr; time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : register ; returning time: 16:01:06 06/16/09 FLE Daylight Time}

# { SyncManager4Xi : __init__ ; step 3/5m registered:Array4Xi registered as Array4Xi with ArrayProxy4Xi; time: 16:01:06 06/16/09 FLE Daylight Time}

#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of arrayproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
 